/*****************************************************************/
/*                                                               */
/*   CASIO fx-9860G SDK Library                                  */
/*                                                               */
/*   File name : [ProjectName].c                                 */
/*                                                               */
/*   Copyright (c) 2006 CASIO COMPUTER CO., LTD.                 */
/*                                                               */
/*****************************************************************/
#include "fxlib.h"
#include "revolution.h"
#include "stdlib.h"
#include "export.h"

void intToString (int n, char* string);

void drawGrayTile (unsigned char *lightBuffer, unsigned char *darkBuffer, GrayTile bitmap, short x, short y);

void drawBitmap(unsigned char *buffer, unsigned char *bitmap, short x, short y, unsigned char w, unsigned char h);

void freeTile(GrayTile *tile);


//****************************************************************************
//  AddIn_main (Sample program main function)
//
//  param   :   isAppli   : 1 = This application is launched by MAIN MENU.
//                        : 0 = This application is launched by a strip in eACT application.
//
//              OptionNum : Strip number (0~3)
//                         (This parameter is only used when isAppli parameter is 0.)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************
int AddIn_main(int isAppli, unsigned short OptionNum)
{
    unsigned int key;
	unsigned char *dyna = 0;
	int light, dark;
	unsigned char contrast, state, rePush, rePushAlpha;
	int checksum, factor, tileNumber = 0;
	char string[15];
	unsigned char light_buffer[1024] = {0}, dark_buffer[1024] = {0};
	GrayTile test = {0,0,0,0};
	
	int *test2;
	
	*(test2 = malloc(sizeof(int))) = 3269;
	
    Bdisp_AllClr_DDVRAM();
	RTCStart();
	srand (RTCReadSecond() + RTCReadMinute()*60 + RTCReadHour()*3600);
	
	light = *test2;
	dark = 6987;
	checksum = light + dark;
	
	intToString (light, string);
	CoolText(0, 0, FONT_FIVE, string, light_buffer);
	CoolText(0, 0, FONT_FIVE, string, dark_buffer);
	intToString (dark, string);
	CoolText(0, 7, FONT_FIVE, string, light_buffer);
	CoolText(0, 7, FONT_FIVE, string, dark_buffer);
	
	GrayLinkBuffers(&light_buffer, &dark_buffer);
	GrayInit(dark, light);
	
	InvertArea (7, 15, 13, 63, light_buffer);
	InvertArea (14, 15, 27, 63, dark_buffer);
	InvertArea (21, 15, 27, 63, light_buffer);
	
	InvertArea (41, 0, 60, 63, light_buffer);
	InvertArea (61, 0, 100, 63, dark_buffer);
	InvertArea (81, 0, 100, 63, light_buffer);
	
	test = aTile(tileNumber);
	drawGrayTile(light_buffer, dark_buffer, test, 75, 20);
	
	rePush = 1;
	contrast = 127;
	state = 1;
	rePushAlpha = 1;

    while(IsKeyUp (KEY_CTRL_EXIT)){
		Change_Contrast (contrast);
		if (IsKeyDown(KEY_CTRL_EXE)) {
			dark = rand() % 5500 + 500;
			light =  rand() % (dark - 500) +50;
		}
		if (IsKeyDown(KEY_CTRL_SHIFT)) factor = 100;
		else if (IsKeyDown(KEY_CTRL_OPTN)) factor = 1000;
		else factor = 1;
		if (IsKeyDown(KEY_CTRL_F1)) light += factor;
		if (IsKeyDown(KEY_CTRL_F2)) light -= factor;
		if (IsKeyDown(KEY_CTRL_F5)) dark += factor;
		if (IsKeyDown(KEY_CTRL_F6)) dark -= factor;
		if (checksum != light + dark) {
			GrayLinkBuffers(&light_buffer, &dark_buffer);
			GrayInit(dark, light);
			ClearArea (0, 0, 30, 14, light_buffer);
			ClearArea (0, 0, 30, 14, dark_buffer);
			intToString (light, string);
			CoolText(0, 0, FONT_FIVE, string, light_buffer);
			CoolText(0, 0, FONT_FIVE, string, dark_buffer);
			intToString (dark, string);
			CoolText(0, 7, FONT_FIVE, string, light_buffer);
			CoolText(0, 7, FONT_FIVE, string, dark_buffer);
	
			checksum = light + dark;
		}
		if (IsKeyDown(KEY_CTRL_UP) && rePush) {
			contrast++;
			rePush = 0;
			}
		if (IsKeyDown(KEY_CTRL_DOWN) && rePush) {
			contrast--;
			rePush = 0;
			}
		if (IsKeyUp(KEY_CTRL_DOWN) && IsKeyUp(KEY_CTRL_UP)) rePush = 1;
		if (IsKeyDown(KEY_CHAR_PLUS)) {
			tileNumber++;
			freeTile(&test);
			test = aTile(tileNumber);
			ClearArea(61, 0, 100, 63, dark_buffer);
			ClearArea(61, 0, 100, 63, light_buffer);
			InvertArea (61, 0, 100, 63, dark_buffer);
			InvertArea (81, 0, 100, 63, light_buffer);
			drawGrayTile(light_buffer, dark_buffer, test, 75, 20);
		}
		if (IsKeyDown(KEY_CHAR_MINUS)) {
			tileNumber--;
			if (tileNumber < 0) tileNumber = 0;
			freeTile(&test);
			test = aTile(tileNumber);
			ClearArea(61, 0, 100, 63, dark_buffer);
			ClearArea(61, 0, 100, 63, light_buffer);
			InvertArea (61, 0, 100, 63, dark_buffer);
			InvertArea (81, 0, 100, 63, light_buffer);
			drawGrayTile(light_buffer, dark_buffer, test, 75, 20);
		}
		
		if (IsKeyDown(KEY_CTRL_ALPHA) && state == 1 && rePushAlpha == 1) {
			GrayEnd();
			state = 0;
			rePushAlpha = 0;
		}
		if (IsKeyDown(KEY_CTRL_ALPHA) && state == 0 && rePushAlpha == 1) {
			GrayLinkBuffers(&light_buffer, &dark_buffer);
			GrayInit(dark, light);
			state = 1;
			rePushAlpha = 0;
		}
		if (IsKeyUp(KEY_CTRL_ALPHA)) rePushAlpha = 1;
    }
	
	CPUSpeedNormal();
    Reset_Calc();
	return 1;
}




void intToString (int n, char* string) {
	int  i;
	int  cpt;
  
	for (i = 1, cpt = 1; n / i >= 10; i *= 10, cpt++);
	for (cpt = 0; i; cpt++, i /= 10) string[cpt] = (n / i) % 10 + '0';
	string[cpt] = '\0';
}


void drawGrayTile (unsigned char *lightBuffer, unsigned char *darkBuffer, GrayTile bitmap, short x, short y) {
	drawBitmap(lightBuffer, bitmap.light, x, y, bitmap.width, bitmap.height);
	drawBitmap(darkBuffer, bitmap.dark, x, y, bitmap.width, bitmap.height);
}


void drawBitmap(unsigned char *buffer, unsigned char *bitmap, short x, short y, unsigned char w, unsigned char h) {
	if (x>-w && y>-h && x<128 && y<64) {
		char shift = x%8;
		char eshift = (x+w)%8;
		char lineLenght = (w-1)/8+1;
		short start = y*16+(x-1)/8+1;
		int i;
		for (i=0; i<h; i++) {
			int j = 8-shift, k=1;
			buffer[start] = (buffer[start] & ~(0xFF >> shift)) | (bitmap[i*lineLenght] >> shift);
			while (j+8<w) {
				buffer[start+k] = (bitmap[i*lineLenght+k-1] << (8-shift)) | (bitmap[i*lineLenght+k] >> shift);
				k++;
				j+=8;
			}
			if (j<w) {
				if ((shift + w%8) > 8) buffer[start+k] = (buffer[start+k] & (0xFF >> eshift)) | ((bitmap[i*lineLenght+k-1] << (8-shift)) & ~(0xFF >> eshift));
				else buffer[start+k] = (bitmap[i*lineLenght+k-1] << (8-shift)) | (buffer[start+k] & (0xFF >> eshift)) | ((bitmap[i*lineLenght+k] >> shift) & ~(0xFF >> eshift) & (0xFF >> shift));
			}
			start += 16;
		}
	}
}


void freeTile(GrayTile *tile) {
	if (tile->light != 0) free(tile->light);
	if (tile->dark != 0) free(tile->dark);
	tile->light = 0;
	tile->dark = 0;
	tile->width = 0;
	tile->height = 0;
}

//****************************************************************************
//**************                                              ****************
//**************                 Notice!                      ****************
//**************                                              ****************
//**************  Please do not change the following source.  ****************
//**************                                              ****************
//****************************************************************************


#pragma section _BR_Size
unsigned long BR_Size;
#pragma section


#pragma section _TOP

//****************************************************************************
//  InitializeSystem
//
//  param   :   isAppli   : 1 = Application / 0 = eActivity
//              OptionNum : Option Number (only eActivity)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************
int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}

#pragma section

