typedef struct {
    unsigned char *light;
    unsigned char *dark;
    unsigned char width;
    unsigned char height;
} GrayTile;

typedef struct {
    unsigned char size;
    GrayTile **tiles;
} Tileset;

typedef struct {
    Tileset tileset;
    unsigned char width;
    unsigned char height;
    unsigned char *map;
} Map;

enum Tiles {t_arbre01, t_door001, t_herbe01, t_herbe1, t_herbe2, t_herbe100, t_housedb1, t_housegb1, t_lit001, t_merdc1, t_murbc1, t_murbd1, t_murbg1, t_murcd1, t_pc01, t_perso001, t_perso002, t_perso02, t_perso03, t_perso004, t_perso04, t_perso005, t_perso05, t_pierre01, t_porte001, t_puis1, t_riv001, t_riv002, t_sacha01, t_sacha1, t_bale01, t_routeg1, t_routed1, t_route_angle_haut, t_route_bas, t_route_angle_bas_droite, t_route_angle_haut_droite, t_route_angle_haut_gauche, t_route_angle_bas_gauche, t_void, t_tile_12___1, t_tile_12___2};

enum Tilesets {ts_exterieur_1, ts_nouveau_tileset, ts_test_12_12, };


GrayTile aTile(int tileId){
    GrayTile ret = {0,0,0,0};
    unsigned char *l=0, *d=0;
    switch (tileId) {
    case t_arbre01 :
        l = (unsigned char*) malloc(32);
        d = (unsigned char*) malloc(32);
        ret.width = 16;
        ret.height = 16; 
        {
            unsigned char l_tmp[] = {0x0, 0x0, 0x7, 0xC0, 0x3F, 0xF8, 0x7F, 0xFC, 0xFF, 0xFE, 0xFF, 0xFE, 0xFF, 0xFE, 0xFF, 0xFE, 0xFF, 0xFE, 0x7F, 0xFC, 0x1F, 0xF0, 0x4, 0xC0, 0x4, 0xF0, 0x6, 0xC0, 0x4, 0xC0, 0x8, 0xE0};
            unsigned char d_tmp[] = {0x0, 0x0, 0x7, 0xC0, 0x3A, 0xF8, 0x5F, 0xAC, 0xBE, 0xFE, 0xD7, 0xBA, 0xBF, 0xFE, 0xEF, 0xEA, 0xBF, 0xFE, 0x7F, 0xEC, 0x1F, 0xF0, 0x7, 0x40, 0x7, 0x30, 0x7, 0x40, 0x7, 0x40, 0xF, 0x20};
            ret.light = (unsigned char*)memcpy((void*)l, (void*)l_tmp, 32);
            ret.dark = (unsigned char*)memcpy((void*)d, (void*)d_tmp, 32);
        }
        break;
    case t_door001 :
        l = (unsigned char*) malloc(32);
        d = (unsigned char*) malloc(32);
        ret.width = 16;
        ret.height = 16; 
        {
            unsigned char l_tmp[] = {0x0, 0x0, 0x1E, 0x0, 0x21, 0x0, 0x40, 0x80, 0x40, 0x80, 0x50, 0x80, 0x40, 0x80, 0x40, 0x80, 0x40, 0x80, 0xFF, 0xC0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0};
            unsigned char d_tmp[] = {0x0, 0x0, 0x1E, 0x0, 0x21, 0x0, 0x40, 0x80, 0x40, 0x80, 0x50, 0x80, 0x40, 0x80, 0x40, 0x80, 0x40, 0x80, 0xFF, 0xC0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0};
            ret.light = (unsigned char*)memcpy((void*)l, (void*)l_tmp, 32);
            ret.dark = (unsigned char*)memcpy((void*)d, (void*)d_tmp, 32);
        }
        break;
    case t_herbe01 :
        l = (unsigned char*) malloc(32);
        d = (unsigned char*) malloc(32);
        ret.width = 16;
        ret.height = 16; 
        {
            unsigned char l_tmp[] = {0x0, 0x0, 0x0, 0x0, 0x55, 0x50, 0x38, 0xE0, 0x10, 0x40, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x55, 0x50, 0x38, 0xE0, 0x10, 0x40, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0};
            unsigned char d_tmp[] = {0x0, 0x0, 0x0, 0x0, 0x55, 0x50, 0x38, 0xE0, 0x10, 0x40, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x55, 0x50, 0x38, 0xE0, 0x10, 0x40, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0};
            ret.light = (unsigned char*)memcpy((void*)l, (void*)l_tmp, 32);
            ret.dark = (unsigned char*)memcpy((void*)d, (void*)d_tmp, 32);
        }
        break;
    case t_herbe1 :
        l = (unsigned char*) malloc(32);
        d = (unsigned char*) malloc(32);
        ret.width = 16;
        ret.height = 16; 
        {
            unsigned char l_tmp[] = {0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0};
            unsigned char d_tmp[] = {0x0, 0x0, 0x50, 0x0, 0x50, 0xA0, 0x22, 0xA0, 0x22, 0xC0, 0x1, 0x80, 0x0, 0x80, 0x0, 0x15, 0x0, 0xE, 0x50, 0x4, 0x54, 0x0, 0x38, 0x0, 0x11, 0x50, 0x0, 0xE0, 0x0, 0x40, 0x0, 0x0};
            ret.light = (unsigned char*)memcpy((void*)l, (void*)l_tmp, 32);
            ret.dark = (unsigned char*)memcpy((void*)d, (void*)d_tmp, 32);
        }
        break;
    case t_herbe2 :
        l = (unsigned char*) malloc(32);
        d = (unsigned char*) malloc(32);
        ret.width = 16;
        ret.height = 16; 
        {
            unsigned char l_tmp[] = {0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0};
            unsigned char d_tmp[] = {0x0, 0x0, 0x48, 0x0, 0x52, 0x80, 0x32, 0xA0, 0x22, 0xC0, 0x1, 0x80, 0x0, 0x92, 0x0, 0x14, 0xA, 0xE, 0x52, 0x4, 0x54, 0x50, 0x38, 0x60, 0x10, 0xD0, 0x0, 0x60, 0x0, 0x40, 0x0, 0x0};
            ret.light = (unsigned char*)memcpy((void*)l, (void*)l_tmp, 32);
            ret.dark = (unsigned char*)memcpy((void*)d, (void*)d_tmp, 32);
        }
        break;
    case t_herbe100 :
        l = (unsigned char*) malloc(24);
        d = (unsigned char*) malloc(24);
        ret.width = 12;
        ret.height = 12; 
        {
            unsigned char l_tmp[] = {0x0, 0x0, 0x28, 0x0, 0x10, 0x0, 0x2, 0x80, 0x1, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x21, 0x40, 0x0, 0x80, 0x0, 0x0, 0x0, 0x0};
            unsigned char d_tmp[] = {0x0, 0x0, 0x28, 0x0, 0x10, 0x0, 0x2, 0x80, 0x1, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x21, 0x40, 0x0, 0x80, 0x0, 0x0, 0x0, 0x0};
            ret.light = (unsigned char*)memcpy((void*)l, (void*)l_tmp, 24);
            ret.dark = (unsigned char*)memcpy((void*)d, (void*)d_tmp, 24);
        }
        break;
    case t_housedb1 :
        l = (unsigned char*) malloc(20);
        d = (unsigned char*) malloc(20);
        ret.width = 10;
        ret.height = 10; 
        {
            unsigned char l_tmp[] = {0x0, 0x80, 0x0, 0x80, 0x7C, 0x80, 0x54, 0x80, 0x7C, 0x80, 0x54, 0x80, 0x7C, 0x80, 0x0, 0x80, 0x0, 0x80, 0xFF, 0x80};
            unsigned char d_tmp[] = {0x0, 0x80, 0x0, 0x80, 0x7C, 0x80, 0x54, 0x80, 0x7C, 0x80, 0x54, 0x80, 0x7C, 0x80, 0x0, 0x80, 0x0, 0x80, 0xFF, 0x80};
            ret.light = (unsigned char*)memcpy((void*)l, (void*)l_tmp, 20);
            ret.dark = (unsigned char*)memcpy((void*)d, (void*)d_tmp, 20);
        }
        break;
    case t_housegb1 :
        l = (unsigned char*) malloc(20);
        d = (unsigned char*) malloc(20);
        ret.width = 10;
        ret.height = 10; 
        {
            unsigned char l_tmp[] = {0x40, 0x0, 0x40, 0x0, 0x4F, 0x80, 0x4A, 0x80, 0x4F, 0x80, 0x4A, 0x80, 0x4F, 0x80, 0x40, 0x0, 0x40, 0x0, 0x7F, 0xC0};
            unsigned char d_tmp[] = {0x40, 0x0, 0x40, 0x0, 0x4F, 0x80, 0x4A, 0x80, 0x4F, 0x80, 0x4A, 0x80, 0x4F, 0x80, 0x40, 0x0, 0x40, 0x0, 0x7F, 0xC0};
            ret.light = (unsigned char*)memcpy((void*)l, (void*)l_tmp, 20);
            ret.dark = (unsigned char*)memcpy((void*)d, (void*)d_tmp, 20);
        }
        break;
    case t_lit001 :
        l = (unsigned char*) malloc(32);
        d = (unsigned char*) malloc(32);
        ret.width = 16;
        ret.height = 16; 
        {
            unsigned char l_tmp[] = {0x0, 0x0, 0x3F, 0xE0, 0x40, 0x10, 0x4F, 0x98, 0x4F, 0xD8, 0x6E, 0x38, 0x5C, 0x18, 0x40, 0x98, 0x41, 0x18, 0x40, 0x18, 0x50, 0x58, 0x48, 0x98, 0x40, 0x18, 0x40, 0x38, 0x3F, 0xF8, 0x1F, 0xF0};
            unsigned char d_tmp[] = {0x0, 0x0, 0x3F, 0xE0, 0x40, 0x10, 0x4F, 0x98, 0x4F, 0xD8, 0x6E, 0x38, 0x5C, 0x18, 0x40, 0x98, 0x41, 0x18, 0x40, 0x18, 0x50, 0x58, 0x48, 0x98, 0x40, 0x18, 0x40, 0x38, 0x3F, 0xF8, 0x1F, 0xF0};
            ret.light = (unsigned char*)memcpy((void*)l, (void*)l_tmp, 32);
            ret.dark = (unsigned char*)memcpy((void*)d, (void*)d_tmp, 32);
        }
        break;
    case t_merdc1 :
        l = (unsigned char*) malloc(20);
        d = (unsigned char*) malloc(20);
        ret.width = 10;
        ret.height = 10; 
        {
            unsigned char l_tmp[] = {0xEF, 0x0, 0xDB, 0x0, 0xDA, 0x0, 0xB6, 0x0, 0x6F, 0x0, 0xDD, 0x80, 0xDB, 0x0, 0xBB, 0x0, 0x76, 0x0, 0xEF, 0x0};
            unsigned char d_tmp[] = {0xEF, 0x0, 0xDB, 0x0, 0xDA, 0x0, 0xB6, 0x0, 0x6F, 0x0, 0xDD, 0x80, 0xDB, 0x0, 0xBB, 0x0, 0x76, 0x0, 0xEF, 0x0};
            ret.light = (unsigned char*)memcpy((void*)l, (void*)l_tmp, 20);
            ret.dark = (unsigned char*)memcpy((void*)d, (void*)d_tmp, 20);
        }
        break;
    case t_murbc1 :
        l = (unsigned char*) malloc(32);
        d = (unsigned char*) malloc(32);
        ret.width = 16;
        ret.height = 16; 
        {
            unsigned char l_tmp[] = {0x50, 0x10, 0x32, 0x14, 0x14, 0x18, 0x10, 0x90, 0xFF, 0xFF, 0x10, 0x14, 0x51, 0x12, 0x90, 0x50, 0x14, 0x10, 0xFF, 0xFF, 0x10, 0x14, 0x12, 0x50, 0x51, 0x10, 0x30, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF};
            unsigned char d_tmp[] = {0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0xFF, 0xFF, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0xFF, 0xFF, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0xFF, 0xFF, 0xFF, 0xFF};
            ret.light = (unsigned char*)memcpy((void*)l, (void*)l_tmp, 32);
            ret.dark = (unsigned char*)memcpy((void*)d, (void*)d_tmp, 32);
        }
        break;
    case t_murbd1 :
        l = (unsigned char*) malloc(32);
        d = (unsigned char*) malloc(32);
        ret.width = 16;
        ret.height = 16; 
        {
            unsigned char l_tmp[] = {0x84, 0x43, 0x4, 0x87, 0x24, 0x4B, 0x44, 0x23, 0xFF, 0xFF, 0x84, 0x3, 0x5, 0x23, 0x24, 0x4B, 0x14, 0x27, 0xFF, 0xFF, 0x6, 0x3, 0x24, 0x13, 0x14, 0x8B, 0x7, 0x3, 0xFF, 0xFF, 0xFF, 0xFF};
            unsigned char d_tmp[] = {0x4, 0x3, 0x4, 0x3, 0x4, 0x3, 0x4, 0x3, 0xFF, 0xFF, 0x4, 0x3, 0x4, 0x3, 0x4, 0x3, 0x4, 0x3, 0xFF, 0xFF, 0x4, 0x3, 0x4, 0x3, 0x4, 0x3, 0x4, 0x3, 0xFF, 0xFF, 0xFF, 0xFF};
            ret.light = (unsigned char*)memcpy((void*)l, (void*)l_tmp, 32);
            ret.dark = (unsigned char*)memcpy((void*)d, (void*)d_tmp, 32);
        }
        break;
    case t_murbg1 :
        l = (unsigned char*) malloc(32);
        d = (unsigned char*) malloc(32);
        ret.width = 16;
        ret.height = 16; 
        {
            unsigned char l_tmp[] = {0xC0, 0x20, 0xD1, 0x24, 0xE2, 0x28, 0xC1, 0x20, 0xFF, 0xFF, 0xC0, 0x20, 0xC8, 0x2C, 0xC5, 0x20, 0xD0, 0xA6, 0xFF, 0xF9, 0xC0, 0x20, 0xE4, 0x22, 0xC1, 0x24, 0xCC, 0x20, 0xFF, 0xFF, 0xFF, 0xFF};
            unsigned char d_tmp[] = {0xC0, 0x20, 0xC0, 0x20, 0xC0, 0x20, 0xC0, 0x20, 0xFF, 0xFF, 0xC0, 0x20, 0xC0, 0x20, 0xC0, 0x20, 0xC0, 0x26, 0xFF, 0xF9, 0xC0, 0x20, 0xC0, 0x20, 0xC0, 0x20, 0xC0, 0x20, 0xFF, 0xFF, 0xFF, 0xFF};
            ret.light = (unsigned char*)memcpy((void*)l, (void*)l_tmp, 32);
            ret.dark = (unsigned char*)memcpy((void*)d, (void*)d_tmp, 32);
        }
        break;
    case t_murcd1 :
        l = (unsigned char*) malloc(32);
        d = (unsigned char*) malloc(32);
        ret.width = 16;
        ret.height = 16; 
        {
            unsigned char l_tmp[] = {0x4, 0x3, 0x14, 0x87, 0x4D, 0x23, 0x84, 0x13, 0xFF, 0xFF, 0x4, 0x3, 0x44, 0x8B, 0x24, 0x23, 0x55, 0x13, 0x4, 0x3, 0xFF, 0xFF, 0xC, 0xB, 0x5, 0x13, 0x44, 0x83, 0x8C, 0x93, 0xFF, 0xFF};
            unsigned char d_tmp[] = {0x4, 0x3, 0x4, 0x3, 0x4, 0x3, 0x4, 0x3, 0xFF, 0xFF, 0x4, 0x3, 0x4, 0x3, 0x4, 0x3, 0x4, 0x3, 0x4, 0x3, 0xFF, 0xFF, 0x4, 0x3, 0x4, 0x3, 0x4, 0x3, 0x4, 0x3, 0xFF, 0xFF};
            ret.light = (unsigned char*)memcpy((void*)l, (void*)l_tmp, 32);
            ret.dark = (unsigned char*)memcpy((void*)d, (void*)d_tmp, 32);
        }
        break;
    case t_pc01 :
        l = (unsigned char*) malloc(32);
        d = (unsigned char*) malloc(32);
        ret.width = 16;
        ret.height = 16; 
        {
            unsigned char l_tmp[] = {0x3F, 0x0, 0x7F, 0x80, 0x40, 0x80, 0x40, 0x80, 0x40, 0x80, 0x7F, 0x80, 0x1E, 0x0, 0x7F, 0x80, 0x71, 0x80, 0x7F, 0x80, 0x0, 0x20, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0};
            unsigned char d_tmp[] = {0x3F, 0x0, 0x7F, 0x80, 0x40, 0x80, 0x40, 0x80, 0x40, 0x80, 0x7F, 0x80, 0x1E, 0x0, 0x7F, 0x80, 0x71, 0x80, 0x7F, 0x80, 0x0, 0x20, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0};
            ret.light = (unsigned char*)memcpy((void*)l, (void*)l_tmp, 32);
            ret.dark = (unsigned char*)memcpy((void*)d, (void*)d_tmp, 32);
        }
        break;
    case t_perso001 :
        l = (unsigned char*) malloc(32);
        d = (unsigned char*) malloc(32);
        ret.width = 16;
        ret.height = 16; 
        {
            unsigned char l_tmp[] = {0xC, 0xA0, 0x1E, 0xE0, 0xF, 0xF8, 0x1F, 0xFC, 0xF, 0xF0, 0xB, 0xD0, 0xA, 0x50, 0xA, 0x50, 0x4, 0x20, 0x3, 0xC0, 0x7, 0xF0, 0xE, 0xE8, 0x15, 0xF0, 0xF, 0xE0, 0x6, 0x60, 0x6, 0x60};
            unsigned char d_tmp[] = {0xC, 0xA0, 0x1E, 0xE0, 0xF, 0xF8, 0x1F, 0xFC, 0xF, 0xF0, 0xB, 0xD0, 0xA, 0x50, 0xA, 0x50, 0x4, 0x20, 0x3, 0xC0, 0x7, 0xF0, 0xE, 0xE8, 0x15, 0xF0, 0xF, 0xE0, 0x6, 0x60, 0x6, 0x60};
            ret.light = (unsigned char*)memcpy((void*)l, (void*)l_tmp, 32);
            ret.dark = (unsigned char*)memcpy((void*)d, (void*)d_tmp, 32);
        }
        break;
    case t_perso002 :
        l = (unsigned char*) malloc(32);
        d = (unsigned char*) malloc(32);
        ret.width = 16;
        ret.height = 16; 
        {
            unsigned char l_tmp[] = {0xC, 0xA0, 0x1E, 0xE0, 0xF, 0xF8, 0x1F, 0xFC, 0xF, 0xF0, 0xB, 0xD0, 0xA, 0x50, 0xA, 0x50, 0x4, 0x20, 0x3, 0xC0, 0x7, 0xF0, 0xB, 0xE8, 0xF, 0xB0, 0x7, 0xE0, 0x6, 0x60, 0x6, 0x60};
            unsigned char d_tmp[] = {0xC, 0xA0, 0x1E, 0xE0, 0xF, 0xF8, 0x1F, 0xFC, 0xF, 0xF0, 0xB, 0xD0, 0xA, 0x50, 0xA, 0x50, 0x4, 0x20, 0x3, 0xC0, 0x7, 0xF0, 0xB, 0xE8, 0xF, 0xB0, 0x7, 0xE0, 0x6, 0x60, 0x6, 0x60};
            ret.light = (unsigned char*)memcpy((void*)l, (void*)l_tmp, 32);
            ret.dark = (unsigned char*)memcpy((void*)d, (void*)d_tmp, 32);
        }
        break;
    case t_perso02 :
        l = (unsigned char*) malloc(20);
        d = (unsigned char*) malloc(20);
        ret.width = 10;
        ret.height = 10; 
        {
            unsigned char l_tmp[] = {0x1F, 0x0, 0x2D, 0x80, 0x3F, 0x80, 0x2A, 0x80, 0x2A, 0x80, 0x11, 0x0, 0x1F, 0x80, 0x2F, 0x40, 0x3F, 0x80, 0x1B, 0x0};
            unsigned char d_tmp[] = {0x1F, 0x0, 0x2D, 0x80, 0x3F, 0x80, 0x2A, 0x80, 0x2A, 0x80, 0x11, 0x0, 0x1F, 0x80, 0x2F, 0x40, 0x3F, 0x80, 0x1B, 0x0};
            ret.light = (unsigned char*)memcpy((void*)l, (void*)l_tmp, 20);
            ret.dark = (unsigned char*)memcpy((void*)d, (void*)d_tmp, 20);
        }
        break;
    case t_perso03 :
        l = (unsigned char*) malloc(20);
        d = (unsigned char*) malloc(20);
        ret.width = 10;
        ret.height = 10; 
        {
            unsigned char l_tmp[] = {0x3E, 0x0, 0x67, 0x80, 0x7F, 0x0, 0x75, 0x0, 0x21, 0x0, 0x1E, 0x0, 0x3E, 0x0, 0x3A, 0x0, 0x1E, 0x0, 0xC, 0x0};
            unsigned char d_tmp[] = {0x3E, 0x0, 0x67, 0x80, 0x7F, 0x0, 0x75, 0x0, 0x21, 0x0, 0x1E, 0x0, 0x3E, 0x0, 0x3A, 0x0, 0x1E, 0x0, 0xC, 0x0};
            ret.light = (unsigned char*)memcpy((void*)l, (void*)l_tmp, 20);
            ret.dark = (unsigned char*)memcpy((void*)d, (void*)d_tmp, 20);
        }
        break;
    case t_perso004 :
        l = (unsigned char*) malloc(32);
        d = (unsigned char*) malloc(32);
        ret.width = 16;
        ret.height = 16; 
        {
            unsigned char l_tmp[] = {0x7, 0xE0, 0x1F, 0xF8, 0x3F, 0xFC, 0x39, 0x9C, 0x7A, 0x5E, 0x7A, 0x5E, 0x7D, 0xBE, 0x7B, 0xDE, 0x36, 0xAC, 0x5, 0x60, 0x6, 0xA0, 0xD, 0x50, 0x1A, 0xA8, 0x35, 0x54, 0x6A, 0xAA, 0x7F, 0xFE};
            unsigned char d_tmp[] = {0x7, 0xE0, 0x1F, 0xF8, 0x3F, 0xFC, 0x39, 0x9C, 0x7A, 0x5E, 0x7A, 0x5E, 0x7D, 0xBE, 0x7B, 0xDE, 0x36, 0xAC, 0x5, 0x60, 0x6, 0xA0, 0xD, 0x50, 0x1A, 0xA8, 0x35, 0x54, 0x6A, 0xAA, 0x7F, 0xFE};
            ret.light = (unsigned char*)memcpy((void*)l, (void*)l_tmp, 32);
            ret.dark = (unsigned char*)memcpy((void*)d, (void*)d_tmp, 32);
        }
        break;
    case t_perso04 :
        l = (unsigned char*) malloc(20);
        d = (unsigned char*) malloc(20);
        ret.width = 10;
        ret.height = 10; 
        {
            unsigned char l_tmp[] = {0x1F, 0x0, 0x20, 0x80, 0x3F, 0x80, 0x3F, 0x80, 0x2E, 0x80, 0x11, 0x0, 0x1F, 0x80, 0x3F, 0x80, 0x3F, 0x0, 0x1B, 0x0};
            unsigned char d_tmp[] = {0x1F, 0x0, 0x20, 0x80, 0x3F, 0x80, 0x3F, 0x80, 0x2E, 0x80, 0x11, 0x0, 0x1F, 0x80, 0x3F, 0x80, 0x3F, 0x0, 0x1B, 0x0};
            ret.light = (unsigned char*)memcpy((void*)l, (void*)l_tmp, 20);
            ret.dark = (unsigned char*)memcpy((void*)d, (void*)d_tmp, 20);
        }
        break;
    case t_perso005 :
        l = (unsigned char*) malloc(32);
        d = (unsigned char*) malloc(32);
        ret.width = 16;
        ret.height = 16; 
        {
            unsigned char l_tmp[] = {0x3, 0xC0, 0x7, 0xE0, 0x1F, 0xF8, 0x3C, 0x3C, 0x3A, 0x5C, 0xA, 0x50, 0x8, 0x10, 0x4, 0x20, 0x3, 0xC0, 0xC, 0x20, 0x14, 0x30, 0xC, 0x28, 0x7, 0xF0, 0x7, 0xE0, 0x6, 0x60, 0x6, 0x60};
            unsigned char d_tmp[] = {0x3, 0xC0, 0x7, 0xE0, 0x1F, 0xF8, 0x3C, 0x3C, 0x3A, 0x5C, 0xA, 0x50, 0x8, 0x10, 0x4, 0x20, 0x3, 0xC0, 0xC, 0x20, 0x14, 0x30, 0xC, 0x28, 0x7, 0xF0, 0x7, 0xE0, 0x6, 0x60, 0x6, 0x60};
            ret.light = (unsigned char*)memcpy((void*)l, (void*)l_tmp, 32);
            ret.dark = (unsigned char*)memcpy((void*)d, (void*)d_tmp, 32);
        }
        break;
    case t_perso05 :
        l = (unsigned char*) malloc(20);
        d = (unsigned char*) malloc(20);
        ret.width = 10;
        ret.height = 10; 
        {
            unsigned char l_tmp[] = {0x1F, 0x0, 0x3C, 0x80, 0x7F, 0x80, 0x2B, 0x80, 0x21, 0x0, 0x1E, 0x0, 0x1F, 0x0, 0x17, 0x0, 0x1E, 0x0, 0xC, 0x0};
            unsigned char d_tmp[] = {0x1F, 0x0, 0x3C, 0x80, 0x7F, 0x80, 0x2B, 0x80, 0x21, 0x0, 0x1E, 0x0, 0x1F, 0x0, 0x17, 0x0, 0x1E, 0x0, 0xC, 0x0};
            ret.light = (unsigned char*)memcpy((void*)l, (void*)l_tmp, 20);
            ret.dark = (unsigned char*)memcpy((void*)d, (void*)d_tmp, 20);
        }
        break;
    case t_pierre01 :
        l = (unsigned char*) malloc(32);
        d = (unsigned char*) malloc(32);
        ret.width = 16;
        ret.height = 16; 
        {
            unsigned char l_tmp[] = {0x0, 0x0, 0x0, 0x0, 0x1, 0xA0, 0x2, 0x70, 0x4, 0x78, 0x8, 0xF8, 0x8, 0xFC, 0x10, 0x7C, 0x10, 0x3E, 0x20, 0x3E, 0x20, 0x3E, 0x20, 0x7E, 0x18, 0x7E, 0x4, 0x3C, 0x3, 0xF0, 0x0, 0x0};
            unsigned char d_tmp[] = {0x0, 0x0, 0x0, 0x0, 0x51, 0xA0, 0x23, 0xD0, 0x27, 0x8A, 0xF, 0xC, 0xF, 0x4, 0x1F, 0x84, 0x1F, 0xC2, 0x3F, 0xC2, 0x3F, 0xC2, 0x3F, 0x82, 0x1F, 0x82, 0x57, 0xCC, 0x23, 0xF0, 0x0, 0x0};
            ret.light = (unsigned char*)memcpy((void*)l, (void*)l_tmp, 32);
            ret.dark = (unsigned char*)memcpy((void*)d, (void*)d_tmp, 32);
        }
        break;
    case t_porte001 :
        l = (unsigned char*) malloc(32);
        d = (unsigned char*) malloc(32);
        ret.width = 16;
        ret.height = 16; 
        {
            unsigned char l_tmp[] = {0x0, 0x0, 0x1F, 0xFC, 0x1F, 0xFC, 0x1F, 0xFE, 0x1F, 0xFE, 0x1F, 0xFE, 0x1F, 0xFC, 0x1F, 0xFC, 0x1F, 0xFC, 0x1F, 0xFC, 0x1F, 0xFE, 0x1F, 0xFE, 0x1F, 0xFE, 0x1F, 0xFC, 0x1F, 0xFC, 0xFF, 0xFF};
            unsigned char d_tmp[] = {0x0, 0x0, 0x1F, 0xFC, 0x10, 0x4, 0x10, 0x6, 0x10, 0x6, 0x10, 0x6, 0x16, 0x4, 0x16, 0x4, 0x10, 0x4, 0x10, 0x4, 0x10, 0x6, 0x10, 0x6, 0x10, 0x6, 0x10, 0x4, 0x10, 0x4, 0xFF, 0xFF};
            ret.light = (unsigned char*)memcpy((void*)l, (void*)l_tmp, 32);
            ret.dark = (unsigned char*)memcpy((void*)d, (void*)d_tmp, 32);
        }
        break;
    case t_puis1 :
        l = (unsigned char*) malloc(32);
        d = (unsigned char*) malloc(32);
        ret.width = 16;
        ret.height = 16; 
        {
            unsigned char l_tmp[] = {0x7, 0xE0, 0x1F, 0xF8, 0x3F, 0xFC, 0x7F, 0xFE, 0x7F, 0xFE, 0x7F, 0xFE, 0x5F, 0xFE, 0x4F, 0xFE, 0x4B, 0xFE, 0x68, 0xFE, 0x58, 0xFE, 0x4C, 0xFE, 0x47, 0xFE, 0x24, 0xFC, 0x1C, 0xF8, 0x7, 0xE0};
            unsigned char d_tmp[] = {0x7, 0xE0, 0x19, 0x18, 0x27, 0xF4, 0x5F, 0xFA, 0x5F, 0xFA, 0x6F, 0xF6, 0x7B, 0xEA, 0x7C, 0x32, 0x7F, 0xE2, 0x7F, 0x26, 0x7F, 0x2A, 0x7F, 0x32, 0x7F, 0xD2, 0x3F, 0x14, 0x1F, 0x18, 0x7, 0xE0};
            ret.light = (unsigned char*)memcpy((void*)l, (void*)l_tmp, 32);
            ret.dark = (unsigned char*)memcpy((void*)d, (void*)d_tmp, 32);
        }
        break;
    case t_riv001 :
        l = (unsigned char*) malloc(32);
        d = (unsigned char*) malloc(32);
        ret.width = 16;
        ret.height = 16; 
        {
            unsigned char l_tmp[] = {0x20, 0x4, 0x10, 0x4, 0x10, 0x2, 0x10, 0x2, 0x20, 0x2, 0x20, 0x4, 0x20, 0x4, 0x40, 0x4, 0x40, 0x8, 0x40, 0x8, 0x40, 0x8, 0x40, 0x8, 0x20, 0x8, 0x20, 0x4, 0x20, 0x4, 0x20, 0x4};
            unsigned char d_tmp[] = {0x20, 0x4, 0x10, 0x4, 0x10, 0x2, 0x10, 0x2, 0x20, 0x2, 0x20, 0x4, 0x20, 0x4, 0x40, 0x4, 0x40, 0x8, 0x40, 0x8, 0x40, 0x8, 0x40, 0x8, 0x20, 0x8, 0x20, 0x4, 0x20, 0x4, 0x20, 0x4};
            ret.light = (unsigned char*)memcpy((void*)l, (void*)l_tmp, 32);
            ret.dark = (unsigned char*)memcpy((void*)d, (void*)d_tmp, 32);
        }
        break;
    case t_riv002 :
        l = (unsigned char*) malloc(32);
        d = (unsigned char*) malloc(32);
        ret.width = 16;
        ret.height = 16; 
        {
            unsigned char l_tmp[] = {0x3F, 0xFC, 0x1C, 0xFC, 0x1F, 0x3E, 0x1F, 0xFE, 0x3F, 0xFE, 0x3F, 0xFC, 0x3F, 0xFC, 0x7F, 0xFC, 0x7F, 0xF8, 0x7F, 0xF8, 0x7F, 0xF8, 0x7F, 0xF8, 0x3F, 0xF8, 0x3F, 0xFC, 0x3F, 0xFC, 0x3F, 0xFC};
            unsigned char d_tmp[] = {0x3F, 0xFC, 0x1C, 0xFC, 0x1F, 0x3E, 0x1F, 0xFE, 0x3F, 0xFE, 0x3F, 0xFC, 0x3F, 0xFC, 0x7F, 0xFC, 0x7F, 0xF8, 0x7F, 0xF8, 0x7F, 0xF8, 0x7F, 0xF8, 0x3F, 0xF8, 0x3F, 0xFC, 0x3F, 0xFC, 0x3F, 0xFC};
            ret.light = (unsigned char*)memcpy((void*)l, (void*)l_tmp, 32);
            ret.dark = (unsigned char*)memcpy((void*)d, (void*)d_tmp, 32);
        }
        break;
    case t_sacha01 :
        l = (unsigned char*) malloc(20);
        d = (unsigned char*) malloc(20);
        ret.width = 10;
        ret.height = 10; 
        {
            unsigned char l_tmp[] = {0x1F, 0x0, 0x2D, 0x80, 0x3F, 0x80, 0x2A, 0x80, 0x2A, 0x80, 0x11, 0x0, 0x3F, 0x0, 0x5E, 0x80, 0x3F, 0x80, 0x1B, 0x0};
            unsigned char d_tmp[] = {0x1F, 0x0, 0x2D, 0x80, 0x3F, 0x80, 0x2A, 0x80, 0x2A, 0x80, 0x11, 0x0, 0x3F, 0x0, 0x5E, 0x80, 0x3F, 0x80, 0x1B, 0x0};
            ret.light = (unsigned char*)memcpy((void*)l, (void*)l_tmp, 20);
            ret.dark = (unsigned char*)memcpy((void*)d, (void*)d_tmp, 20);
        }
        break;
    case t_sacha1 :
        l = (unsigned char*) malloc(20);
        d = (unsigned char*) malloc(20);
        ret.width = 10;
        ret.height = 10; 
        {
            unsigned char l_tmp[] = {0x1F, 0x0, 0x2D, 0x80, 0x3F, 0x80, 0x2A, 0x80, 0x2A, 0x80, 0x11, 0x0, 0x3F, 0x0, 0x5E, 0x80, 0x3F, 0x80, 0x1B, 0x0};
            unsigned char d_tmp[] = {0x1F, 0x0, 0x2D, 0x80, 0x3F, 0x80, 0x2A, 0x80, 0x2A, 0x80, 0x11, 0x0, 0x3F, 0x0, 0x5E, 0x80, 0x3F, 0x80, 0x1B, 0x0};
            ret.light = (unsigned char*)memcpy((void*)l, (void*)l_tmp, 20);
            ret.dark = (unsigned char*)memcpy((void*)d, (void*)d_tmp, 20);
        }
        break;
    case t_bale01 :
        l = (unsigned char*) malloc(32);
        d = (unsigned char*) malloc(32);
        ret.width = 16;
        ret.height = 16; 
        {
            unsigned char l_tmp[] = {0x0, 0x0, 0x0, 0x0, 0xF, 0xFC, 0x30, 0xA, 0x41, 0xA, 0x42, 0x91, 0x81, 0x11, 0x80, 0x11, 0x40, 0x11, 0x40, 0xA, 0x30, 0xA, 0xF, 0xFC, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0};
            unsigned char d_tmp[] = {0x0, 0x0, 0x0, 0x0, 0xF, 0xFC, 0x30, 0xA, 0x41, 0xA, 0x42, 0x91, 0x81, 0x11, 0x80, 0x11, 0x40, 0x11, 0x40, 0xA, 0x30, 0xA, 0xF, 0xFC, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0};
            ret.light = (unsigned char*)memcpy((void*)l, (void*)l_tmp, 32);
            ret.dark = (unsigned char*)memcpy((void*)d, (void*)d_tmp, 32);
        }
        break;
    case t_routeg1 :
        l = (unsigned char*) malloc(32);
        d = (unsigned char*) malloc(32);
        ret.width = 16;
        ret.height = 16; 
        {
            unsigned char l_tmp[] = {0x4, 0x0, 0x4, 0x0, 0x2, 0x0, 0x1, 0x0, 0xE, 0x0, 0x10, 0x0, 0x8, 0x0, 0x8, 0x0, 0x4, 0x0, 0x4, 0x0, 0x4, 0x0, 0x2, 0x0, 0x1, 0x0, 0x2, 0x0, 0x4, 0x0, 0x4, 0x0};
            unsigned char d_tmp[] = {0x4, 0x0, 0x54, 0x0, 0xE2, 0x0, 0x41, 0x0, 0xE, 0x0, 0x10, 0x0, 0x58, 0x0, 0x28, 0x0, 0x4, 0x0, 0x4, 0x0, 0x54, 0x0, 0x52, 0x0, 0x21, 0x0, 0x22, 0x0, 0x4, 0x0, 0x4, 0x0};
            ret.light = (unsigned char*)memcpy((void*)l, (void*)l_tmp, 32);
            ret.dark = (unsigned char*)memcpy((void*)d, (void*)d_tmp, 32);
        }
        break;
    case t_routed1 :
        l = (unsigned char*) malloc(32);
        d = (unsigned char*) malloc(32);
        ret.width = 16;
        ret.height = 16; 
        {
            unsigned char l_tmp[] = {0x0, 0x20, 0x0, 0x20, 0x0, 0x10, 0x0, 0x60, 0x0, 0x80, 0x0, 0x40, 0x0, 0x20, 0x0, 0x20, 0x0, 0x20, 0x0, 0x20, 0x0, 0x40, 0x0, 0x40, 0x0, 0x40, 0x0, 0x80, 0x0, 0x40, 0x0, 0x20};
            unsigned char d_tmp[] = {0x0, 0x20, 0x0, 0x2A, 0x0, 0x14, 0x0, 0x60, 0x0, 0x80, 0x0, 0x4A, 0x0, 0x2B, 0x0, 0x26, 0x0, 0x22, 0x0, 0x20, 0x0, 0x40, 0x0, 0x6A, 0x0, 0x5C, 0x0, 0x88, 0x0, 0x40, 0x0, 0x20};
            ret.light = (unsigned char*)memcpy((void*)l, (void*)l_tmp, 32);
            ret.dark = (unsigned char*)memcpy((void*)d, (void*)d_tmp, 32);
        }
        break;
    case t_route_angle_haut :
        l = (unsigned char*) malloc(32);
        d = (unsigned char*) malloc(32);
        ret.width = 16;
        ret.height = 16; 
        {
            unsigned char l_tmp[] = {0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x10, 0x10, 0x68, 0x2A, 0x89, 0xC5, 0x6, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0};
            unsigned char d_tmp[] = {0x0, 0x0, 0x0, 0xA, 0x15, 0x4, 0xE, 0x0, 0x4, 0xA0, 0x0, 0x40, 0x10, 0x10, 0x68, 0x2A, 0x89, 0xC5, 0x6, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0};
            ret.light = (unsigned char*)memcpy((void*)l, (void*)l_tmp, 32);
            ret.dark = (unsigned char*)memcpy((void*)d, (void*)d_tmp, 32);
        }
        break;
    case t_route_bas :
        l = (unsigned char*) malloc(32);
        d = (unsigned char*) malloc(32);
        ret.width = 16;
        ret.height = 16; 
        {
            unsigned char l_tmp[] = {0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xC, 0x2, 0x92, 0x1D, 0x61, 0x60, 0x0, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0};
            unsigned char d_tmp[] = {0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xC, 0x2, 0x92, 0x1D, 0x61, 0x60, 0x0, 0x80, 0x2A, 0x0, 0x1C, 0x0, 0x8, 0x54, 0x0, 0x38, 0x0, 0x10, 0x0, 0x0};
            ret.light = (unsigned char*)memcpy((void*)l, (void*)l_tmp, 32);
            ret.dark = (unsigned char*)memcpy((void*)d, (void*)d_tmp, 32);
        }
        break;
    case t_route_angle_bas_droite :
        l = (unsigned char*) malloc(32);
        d = (unsigned char*) malloc(32);
        ret.width = 16;
        ret.height = 16; 
        {
            unsigned char l_tmp[] = {0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2, 0x0, 0xD, 0x0, 0x10, 0x0, 0x20, 0x0, 0x40, 0x0, 0x20, 0x0, 0x20, 0x0, 0x10, 0x0, 0x10, 0x0, 0x20};
            unsigned char d_tmp[] = {0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2, 0x0, 0xD, 0x0, 0x10, 0x0, 0x20, 0x0, 0x4A, 0x0, 0x24, 0x0, 0x20, 0x0, 0x10, 0x0, 0x1A, 0x0, 0x24};
            ret.light = (unsigned char*)memcpy((void*)l, (void*)l_tmp, 32);
            ret.dark = (unsigned char*)memcpy((void*)d, (void*)d_tmp, 32);
        }
        break;
    case t_route_angle_haut_droite :
        l = (unsigned char*) malloc(32);
        d = (unsigned char*) malloc(32);
        ret.width = 16;
        ret.height = 16; 
        {
            unsigned char l_tmp[] = {0x0, 0x20, 0x0, 0x40, 0x0, 0x40, 0x0, 0x20, 0x0, 0x20, 0x0, 0x10, 0x0, 0x10, 0x0, 0xC, 0x0, 0x3, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0};
            unsigned char d_tmp[] = {0x0, 0x20, 0x0, 0x4A, 0x0, 0x44, 0x0, 0x20, 0x0, 0x2A, 0x0, 0x17, 0x0, 0x12, 0x0, 0xC, 0x0, 0x3, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0};
            ret.light = (unsigned char*)memcpy((void*)l, (void*)l_tmp, 32);
            ret.dark = (unsigned char*)memcpy((void*)d, (void*)d_tmp, 32);
        }
        break;
    case t_route_angle_haut_gauche :
        l = (unsigned char*) malloc(32);
        d = (unsigned char*) malloc(32);
        ret.width = 16;
        ret.height = 16; 
        {
            unsigned char l_tmp[] = {0x4, 0x0, 0x2, 0x0, 0x2, 0x0, 0x4, 0x0, 0x8, 0x0, 0x4, 0x0, 0x4, 0x0, 0x28, 0x0, 0xD0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0};
            unsigned char d_tmp[] = {0x4, 0x0, 0x52, 0x0, 0x22, 0x0, 0x24, 0x0, 0x8, 0x0, 0xA4, 0x0, 0x44, 0x0, 0x28, 0x0, 0xD0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0};
            ret.light = (unsigned char*)memcpy((void*)l, (void*)l_tmp, 32);
            ret.dark = (unsigned char*)memcpy((void*)d, (void*)d_tmp, 32);
        }
        break;
    case t_route_angle_bas_gauche :
        l = (unsigned char*) malloc(32);
        d = (unsigned char*) malloc(32);
        ret.width = 16;
        ret.height = 16; 
        {
            unsigned char l_tmp[] = {0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xC0, 0x0, 0x30, 0x0, 0x8, 0x0, 0x8, 0x0, 0x4, 0x0, 0x2, 0x0, 0x2, 0x0, 0x4, 0x0, 0x4, 0x0};
            unsigned char d_tmp[] = {0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xC0, 0x0, 0x30, 0x0, 0xA8, 0x0, 0x48, 0x0, 0x4, 0x0, 0xAA, 0x0, 0x72, 0x0, 0x24, 0x0, 0x4, 0x0};
            ret.light = (unsigned char*)memcpy((void*)l, (void*)l_tmp, 32);
            ret.dark = (unsigned char*)memcpy((void*)d, (void*)d_tmp, 32);
        }
        break;
    case t_void :
        l = (unsigned char*) malloc(32);
        d = (unsigned char*) malloc(32);
        ret.width = 16;
        ret.height = 16; 
        {
            unsigned char l_tmp[] = {0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0};
            unsigned char d_tmp[] = {0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0};
            ret.light = (unsigned char*)memcpy((void*)l, (void*)l_tmp, 32);
            ret.dark = (unsigned char*)memcpy((void*)d, (void*)d_tmp, 32);
        }
        break;
    case t_tile_12___1 :
        l = (unsigned char*) malloc(24);
        d = (unsigned char*) malloc(24);
        ret.width = 12;
        ret.height = 12; 
        {
            unsigned char l_tmp[] = {0x0, 0x0, 0x1E, 0x0, 0x39, 0x0, 0x38, 0x80, 0x38, 0x40, 0x38, 0x20, 0x78, 0x10, 0x7C, 0x10, 0x7C, 0x20, 0x3E, 0x20, 0x3E, 0x40, 0x1F, 0x80};
            unsigned char d_tmp[] = {0x0, 0x0, 0x1E, 0x0, 0x27, 0x0, 0x27, 0x80, 0x27, 0xC0, 0x27, 0xE0, 0x47, 0xF0, 0x43, 0xF0, 0x43, 0xE0, 0x21, 0xE0, 0x21, 0xC0, 0x1F, 0x80};
            ret.light = (unsigned char*)memcpy((void*)l, (void*)l_tmp, 24);
            ret.dark = (unsigned char*)memcpy((void*)d, (void*)d_tmp, 24);
        }
        break;
    case t_tile_12___2 :
        l = (unsigned char*) malloc(24);
        d = (unsigned char*) malloc(24);
        ret.width = 12;
        ret.height = 12; 
        {
            unsigned char l_tmp[] = {0x7F, 0xE0, 0x7F, 0xF0, 0x60, 0x70, 0xE0, 0x70, 0xC0, 0x30, 0xC0, 0x30, 0xE0, 0x30, 0xE0, 0x30, 0x70, 0xF0, 0x7F, 0xE0, 0x1F, 0x80, 0x7, 0x0};
            unsigned char d_tmp[] = {0x0, 0x0, 0x1F, 0x80, 0x3F, 0xC0, 0x3F, 0xC0, 0x7E, 0xE0, 0x7D, 0x60, 0x3E, 0xE0, 0x3F, 0xE0, 0x3F, 0xC0, 0xF, 0x0, 0x0, 0x0, 0x0, 0x0};
            ret.light = (unsigned char*)memcpy((void*)l, (void*)l_tmp, 24);
            ret.dark = (unsigned char*)memcpy((void*)d, (void*)d_tmp, 24);
        }
        break;}
    return ret;
}

Tileset aTileset(int tilesetId){
    Tileset ret;
    switch (tilesetId) {
    case ts_exterieur_1 :
        ret.size = 24;
        ret.tiles = calloc (24, sizeof(GrayTile*));
        *(ret.tiles[0] = malloc(sizeof(GrayTile))) = aTile(t_void);
        *(ret.tiles[1] = malloc(sizeof(GrayTile))) = aTile(t_herbe1);
        *(ret.tiles[2] = malloc(sizeof(GrayTile))) = aTile(t_herbe2);
        *(ret.tiles[3] = malloc(sizeof(GrayTile))) = aTile(t_puis1);
        *(ret.tiles[4] = malloc(sizeof(GrayTile))) = aTile(t_pierre01);
        *(ret.tiles[5] = malloc(sizeof(GrayTile))) = aTile(t_arbre01);
        *(ret.tiles[6] = malloc(sizeof(GrayTile))) = aTile(t_riv001);
        *(ret.tiles[7] = malloc(sizeof(GrayTile))) = aTile(t_porte001);
        *(ret.tiles[8] = malloc(sizeof(GrayTile))) = aTile(t_murcd1);
        *(ret.tiles[9] = malloc(sizeof(GrayTile))) = aTile(t_route_angle_haut);
        *(ret.tiles[10] = malloc(sizeof(GrayTile))) = aTile(t_route_angle_haut_gauche);
        *(ret.tiles[11] = malloc(sizeof(GrayTile))) = aTile(t_route_angle_haut_droite);
        *(ret.tiles[12] = malloc(sizeof(GrayTile))) = aTile(t_murbg1);
        *(ret.tiles[13] = malloc(sizeof(GrayTile))) = aTile(t_murbc1);
        *(ret.tiles[14] = malloc(sizeof(GrayTile))) = aTile(t_murbd1);
        *(ret.tiles[15] = malloc(sizeof(GrayTile))) = aTile(t_route_bas);
        *(ret.tiles[16] = malloc(sizeof(GrayTile))) = aTile(t_route_angle_bas_gauche);
        *(ret.tiles[17] = malloc(sizeof(GrayTile))) = aTile(t_route_angle_bas_droite);
        *(ret.tiles[18] = malloc(sizeof(GrayTile))) = aTile(t_lit001);
        *(ret.tiles[19] = malloc(sizeof(GrayTile))) = aTile(t_perso001);
        *(ret.tiles[20] = malloc(sizeof(GrayTile))) = aTile(t_perso002);
        *(ret.tiles[21] = malloc(sizeof(GrayTile))) = aTile(t_riv002);
        *(ret.tiles[22] = malloc(sizeof(GrayTile))) = aTile(t_routeg1);
        *(ret.tiles[23] = malloc(sizeof(GrayTile))) = aTile(t_routed1);
        break;
    case ts_nouveau_tileset :
        ret.size = 16;
        ret.tiles = calloc (16, sizeof(GrayTile*));
        *(ret.tiles[1] = malloc(sizeof(GrayTile))) = aTile(t_door001);
        *(ret.tiles[2] = malloc(sizeof(GrayTile))) = aTile(t_porte001);
        *(ret.tiles[3] = malloc(sizeof(GrayTile))) = aTile(t_murbc1);
        break;
    case ts_test_12_12 :
        ret.size = 2;
        ret.tiles = calloc (2, sizeof(GrayTile*));
        *(ret.tiles[0] = malloc(sizeof(GrayTile))) = aTile(t_tile_12___1);
        *(ret.tiles[1] = malloc(sizeof(GrayTile))) = aTile(t_tile_12___2);
        break;}
    return ret;
}